<?php
function showImg($aPath, $aFn, $aIdx, $aThisPage, $aSubDir="")
{
  global $g_twidth, $g_dispFn, $g_thumb_worh, $g_showInPopup, $g_popupWidth, $g_popupHeight, $g_shrinkPopup;

  $fullpath = $aPath.$aFn;

    $imgsize = GetImageSize($fullpath);
  if($g_thumb_worh == 'w') {
    $twidth = $g_twidth;
    $theight = $imgsize[1] / ($imgsize[0]/$twidth);
  } else {
    $theight = $g_twidth;
    $twidth = $imgsize[0] / ($imgsize[1]/$theight);
  }

   echo "<td>";
  if($aSubDir != "") {
    echo "<center><a href=\"$PHP_SELF?path=$aPath\"><img border=\"0\" width=\"$twidth\" height=\"$theight\" src=\"genthumbs.php?image=$fullpath&w=$twidth\"></img></a></center>";
  } else {
    $sb = "yes";
    if($g_showInPopup == 'check') {
      $w = $g_popupWidth;
      $h = $g_popupHeight;
      if($g_shrinkPopup == 'check') {
        $picsize = GetImageSize($aPath.$aFn);
        if($picsize[0]+10 < $w && $picsize[1]+10 < $h) {
          $w = $picsize[0]+10;
          $h = $picsize[1]+10;
          $sb = "no";
        }
		
      }
      echo "<center><a href=# onclick=\"javascript:window.open('$aPath$aFn', '_blank', 'width=$w, height=$h, scrollbars=$sb');return false\"><img border=\"0\" width=\"$twidth\" height=\"$theight\" src=\"genthumbs.php?image=$fullpath&w=$twidth\"></img></a></center>";
      
    } else
      echo "<center><a href=\"$PHP_SELF?path=$aPath&page=$aThisPage&img=$aFn&idx=$aIdx\"><img border=\"0\" width=\"$twidth\" height=\"$theight\" src=\"genthumbs.php?image=$fullpath&w=$twidth\"></img></a></center>";
  }

  if($g_dispFn) {
    echo "<br><center>";
    if($aSubDir == "") {
      $l = strlen($aFn) - 4;
      echo substr($aFn, 0, $l);
    } else {
      echo $aSubDir."[Carpeta]";
    }
    echo "</center>";
  }
  echo "</td>";

}

function showBigImg($aPath, $aIdx)
{
  global $files, $isDir; 

  echo "<center>";
  echo "<table border=\"0\" cellspacing=\"10\" cellpadding=\"0\">";

  if($isDir[$files[$aIdx]]) {
    showDir($aPath, $files[$aIdx]);
  } else {
        echo "<td>";
    echo "<center><img border=\"0\" src=\"".$aPath.$files[$aIdx]."\"></img></center>";
    echo "</td>";

    echo "</table>";
    echo "</center>";
  }
}

function getFirstImgFn($aPath, $aExt)
{
  $dir_handle = @opendir($aPath) or die("No se pudo abrir $aPath");

  while($file = readdir($dir_handle)) {
    $fullpath = $aPath.$file;

    if(is_dir($fullpath) == false) {
      $ext = substr($file, -4);
      if(strtolower($ext) == $aExt) {
        return $file;
      }
    }
  }

  return "";
}


function getRandomImgFn($aPath, $aExt)
{
  $dir_handle = @opendir($aPath) or die("No se pudo abrir $aPath");

  $imgfiles = array();
  while($file = readdir($dir_handle)) {
    $fullpath = $aPath.$file;

    if(is_dir($fullpath) == false) {
      $ext = substr($file, -4);
      if(strtolower($ext) == $aExt) {
        $imgfiles[] = $file;
      }
    }
  }
  
  $num = count($imgfiles);
  if($num <= 0) {

    return "";
  }


  $idx = rand(0, $num-1);
  return $imgfiles[$idx];  
  
}

function showDir($aPath, $aFn)
{
  global $g_showFirstThumb, $g_folderImg;
  $fullpath = $aPath.$aFn."/";
  
  if($g_folderImg == '3' || $g_folderImg == '4') {
     $fn = "";
     if($g_folderImg == '3')
       $fn = getFirstImgFn($fullpath, '.jpg');
     else
       $fn = getRandomImgFn($fullpath, '.jpg');	
		
     if($fn != "") {
       showImg($fullpath, $fn, "0", "0", $aFn);
       return;
     }
  }

  echo "<td>";
  $done = false;
  
  if($g_folderImg == '2') {
    $fn = getFirstImgFn($fullpath, '.gif');
    if($fn != "") {
      $imgsize = GetImageSize($fullpath.$fn);
      echo "<center><a href=\"$PHP_SELF?path=$fullpath\"><img border=\"0\" width=\"$imgsize[0]\" height=\"$imgsize[1]\" src=\"$fullpath$fn\"></img></a></center>";
      $done = true;
    }
  }
  
 
  if($done == false) {
    $imgsize = GetImageSize("folder.gif");
    echo "<center><a href=\"$PHP_SELF?path=$fullpath\"><img border=\"0\" width=\"$imgsize[0]\" height=\"$imgsize[1]\" src=\"folder.gif\"></img></a></center>";
  }
  
  echo "<br><center>$aFn</center>";
  echo "</td>";

}

function showImgRow($aPath, $aFiles, $aIsDir, $aThisPage, $aStart, $aEnd)
{
  echo "<tr>";
  for($i=$aStart; $i<$aEnd; $i++) {
    if($aIsDir["_".$aFiles[$i]]) {
      showDir($aPath, $aFiles[$i]);
    } else {
      showImg($aPath, $aFiles[$i], $i, $aThisPage);
    }
  }
  echo "</tr>";
}

function showImgTable($aPath, $aFiles, $aIsDir, $aThisPage,
	$aNumCols, $aNumRows)
{
  global $g_spacing;
  
  $numPerPage = $aNumRows * $aNumCols;
  $totalFiles = count($aFiles);
  $start = $aThisPage * $numPerPage;
  $end = $start + $numPerPage;
  $end = min($end, $totalFiles);

  echo "<center>";
  echo "<table border=\"0\" cellspacing=\"$g_spacing\" cellpadding=\"0\">";

  while($start < $end) {
    $e = min($start + $aNumCols, $end);
    showImgRow($aPath, $aFiles, $aIsDir, $aThisPage, $start, $e);
    $start += $aNumCols;
  }

  echo "</table>";
  echo "</center>";
}

function showPageLinks($aPath, $aNumFiles, $aThisPage, $aIdx, $aNumCols, $aNumRows)
{
  global $files;
  $numPerPage = $aNumCols * $aNumRows;
  $numPages = ceil($aNumFiles / $numPerPage);


  $pdir = "";
  $plen = strlen($aPath);
  for($j=$plen-2; $j>0; $j--) {
    if($aPath[$j] == '/') {
      $pdir = substr($aPath, 0, $j+1);
      break;
    }
  }

  echo "<br><center>";
  echo "<table border=\"0\" cellspacing=\"10\" cellpadding=\"0\">";
  echo "<tr>";
  if($aIdx != "") {

    echo "<td><a href=\"$PHP_SELF?path=$aPath&page=$aThisPage\">Volver</a></td>";

    if($aIdx > 0) {
      $idx = $aIdx - 1;
      echo "<td><a href=\"$PHP_SELF?path=$aPath&page=$aThisPage&idx=$idx\">&lt;</a></td>";
    }
    if($aIdx + 1 < count($files)) {
      $idx = $aIdx + 1;
      echo "<td><a href=\"$PHP_SELF?path=$aPath&page=$aThisPage&idx=$idx\">&gt;</a></td>";
    }
  } else {

    if($pdir != "") {
      echo "<td><a href=\"$PHP_SELF?path=$pdir\"><!--Arriba--></a></td>";
    }

    if($numPages == 0) {
      echo "<td>Sin Imagenes</td>";
    } else { 

      $minp = 0;
      $maxp = 10;
      if($numPages > 10) {
        $minp = floor($aThisPage/10) * 10;
        $maxp = ceil(($aThisPage+1)/10) * 10;
      }
      $maxp = min($maxp, $numPages);

      echo "<td>Pagina:</td>";


      if($minp >= 10) {
        $prevp = $minp - 1;
        echo "<td><a href=\"$PHP_SELF?path=$aPath&page=$prevp\">&lt;</a></td>";
      }


      for($i=$minp; $i<$maxp; $i++) {
        $p = $i + 1;
        if($aThisPage == $i) {
          echo "<td><b>$p</b></td>";
        } else {
          echo "<td><a href=\"$PHP_SELF?path=$aPath&page=$i\">$p</a></td>";
        }
      }


      if($maxp < $numPages) {
        $nextp = $maxp;
        echo "<td><a href=\"$PHP_SELF?path=$aPath&page=$nextp\">&gt;</a></td>";
      }
    }
  }
  echo "</tr>";
  echo "</table>";
  echo "</center>";
}


function cicmp($a, $b)
{
  return strcasecmp($a, $b);
}


function readFiles($aPath, &$aFiles, &$aIsDir)
{

  global $g_sortByFn, $g_insensitive_sort;
  $confdir = "imgconfig";

  $dir_handle = @opendir($aPath) or die("No se pudo abrir $aPath");

  while($file = readdir($dir_handle)) {
    $fullpath = $aPath.$file;

    if(is_dir($fullpath)) {
      if($file != '.' && $file != '..' && $file != $confdir) {
        $aFiles[] = $file;
        $tmparray = array("_".$file => true);
        $aIsDir = array_merge($aIsDir, $tmparray);
      }
    } else {
      $ext = substr($file, -4);
      if($file[0] != '.' && (strtolower($ext) == '.jpg')) {
        $aFiles[] = $file;
        $tmparray = array("_".$file => false);
        $aIsDir = array_merge($aIsDir, $tmparray);
      }
    }
    if($g_sortByFn == 'check') {
	  if($g_insensitive_sort == 'check') {
	  	usort($aFiles, "cicmp");
	  } else {
        sort($aFiles);
	  }
    }
  }

  closedir($dir_handle);
}

function adjustPath($aPath)
{
  $ret = $aPath;
  if(!$ret)
    $ret = "./";
  if(substr($ret, -1) != "/")
  $ret = $ret.'/';

  if(substr($ret, 0, 1) != '.' || strstr($ret, "..")) {
    $ret= './';
  }
  
  return $ret;
}

?>
